# Setup script for system INI file
# Setup script is the place to define the migration procedure
import os, sys, logging, ConfigParser, shutil, platform
import setup_util

_ModName = "base"

''' Install to latest '''
def install():
 logging.info("[setup_base.py] start install()")
# #------------ Install SQL Server native client -------------
# logging.info("[setup_base.py] install SQL server native client")
# sqlncli_setup = setup_util.i4j["sys.installationDir"]+"\\db\\dist\\sqlncli.msi"
# sqlncli_keyfile = os.environ['ProgramFiles']+"\\Microsoft SQL Server\\100\\KeyFile\\1033\\sqlncli_keyfile.dll"
# if not os.path.exists(sqlncli_keyfile):
#  setup_opts=' /i "'+sqlncli_setup+'" IACCEPTSQLNCLILICENSETERMS=YES'
#  setup_cmd=setup_util._CmdMsiexec+" /qb "
#  if "UNATTENDED" in os.environ:
#   setup_cmd=setup_util._CmdMsiexec+" /qn "
#  ret, out=setup_util.psys(setup_cmd+setup_opts)
#  if len(out)>0:
#   logging.info(out)
#  #return code is not reliable, check the distributed file instead
#  if not os.path.exists(sqlncli_keyfile):
#   raise Exception("Failed to install SQL server native client")
# else:
#  logging.info("[setup_base.py] SQL Server native client has already been installed")
#  setup_util.safe_remove(sqlncli_setup)
# setup_util.set_progress(40)
# #------------ Install SQL Server sqlcmd utilility -------------
# logging.info("[setup_base.py] force install SQL server sqlcmd command line util")
# sqlcmd_setup = setup_util.i4j["sys.installationDir"]+"\\db\\dist\\SqlCmdLnUtils.msi"
# sqlcmd_keyfile = os.environ['ProgramFiles']+"\\Microsoft SQL Server\\100\\Tools\\Binn\\SQLCMD.EXE"
# if not os.path.exists(sqlcmd_keyfile):
#  setup_opts=' /i "'+sqlcmd_setup+'"'
#  setup_cmd=setup_util._CmdMsiexec+" /qb "
#  if "UNATTENDED" in os.environ:
#   setup_cmd=setup_util._CmdMsiexec+" /qn "
#  ret, out=setup_util.psys(setup_cmd+setup_opts)
#  if len(out)>0:
#   logging.info(out)
# #return code is not reliable, check the distributed file instead
#  if not os.path.exists(sqlcmd_keyfile):
#   raise Exception("Failed to install SQL server sqlcmd command line util")
# else:
#  logging.info("[setup_base.py] SQL Server command line util has already been installed")
#  setup_util.safe_remove(sqlcmd_setup)
# setup_util.set_progress(60)
 #------------ Install Flash player trust-------------
 logging.info("[setup_base.py] configure flash player")
 sys32dir = "System32"
 if platform.architecture()[0]=="64bit":
  sys32dir = "SysWOW64"
 flash_dir = os.path.join(os.environ['SystemRoot'],sys32dir,"Macromed","Flash")
 flash_setup = setup_util.i4j["sys.installationDir"]+"\\3rd_party\\adobe\\install_flash_player.exe"
 flash_keyfile = flash_dir+"\\NPSWF32.dll"
 if not os.path.exists(flash_keyfile):
  setup_cmd='"'+flash_setup+'" -install'
  ret, out=setup_util.psys(setup_cmd)
  if len(out)>0:
   logging.info(out)
  if not os.path.exists(flash_keyfile):
   raise Exception("Failed to install Flash Player")
 else:
  logging.info("[setup_base.py] Flash player has already been installed")
  setup_util.safe_remove(flash_setup)
 logging.info("[setup_base.py] configure flash player trust")
 flash_trust_dir = flash_dir+"\\FlashPlayerTrust"
 if not os.path.exists(flash_trust_dir):
  os.mkdir(flash_trust_dir)
 shutil.copyfile(setup_util.i4j["sys.installationDir"]+"\\web\\htdocs\\configs\\zg.txt", flash_trust_dir+"\\zg.txt")
 setup_util.set_progress(80)
 #------------ Install ImageMagick for PHP -------------
 logging.info("[setup_base.py] install ImageMagic for PHP")
 if not os.path.exists(setup_util.i4j["sys.installationDir"]+"\\3rd_party\\imagemagick\\unins000.exe"):
  imagic_setup = setup_util.i4j["sys.installationDir"]+"\\3rd_party\\imagemagick\\ImageMagick.exe"
  setup_opts=' /TASKS="" /NOICONS /NOCANCEL /DIR="'+setup_util.i4j["sys.installationDir"]+'\\3rd_party\\imagemagick"'
  setup_cmd=imagic_setup+" /SILENT "
  if "UNATTENDED" in os.environ:
   setup_cmd=imagic_setup+" /VERYSILENT "
  ret, out=setup_util.psys(setup_cmd+setup_opts)
  if len(out)>0:
   logging.info(out)
  if not os.path.exists(setup_util.i4j["sys.installationDir"]+"\\3rd_party\\imagemagick\\unins000.exe"):
   raise Exception("Failed to install ImageMagick for PHP")
  setup_util.safe_remove(imagic_setup)
 else:
  logging.info("[setup_base.py] ImageMagick has already been installed")
 logging.info("[setup_base.py] done install()")
 setup_util.set_progress(100)

''' Maintain for upgrade ''' 
def maintain():
 pass

''' Completely uninstall component '''
def uninstall():
 maintain()
 logging.info("[setup_base.py] start uninstall()")
 #------------ Uninstall Imagick ------------------
 logging.info("[setup_base.py] remove imagick")
 imagic_setup = setup_util.i4j["sys.installationDir"]+"\\3rd_party\\imagemagick\\unins000.exe"
 setup_cmd=imagic_setup+" /SILENT"
 if "UNATTENDED" in os.environ:
  setup_cmd=imagic_setup+" /VERYSILENT"
 setup_util.psysi(setup_cmd)
 #------------ Uninstall Flash Player trust------------------
 logging.info("[setup_base.py] remove flash player trust")
 sys32dir = "System32"
 if platform.architecture()[0]=="64bit":
  sys32dir = "SysWOW64"
 flash_dir = os.path.join(os.environ['SystemRoot'],sys32dir,"Macromed","Flash")
 flash_setup = setup_util.i4j["sys.installationDir"]+"\\3rd_party\\adobe\\install_flash_player.exe"
 if os.path.exists(flash_setup):
  setup_cmd='"'+flash_setup+'" -uninstall'
  setup_util.psysi(setup_cmd)
 flash_trust_file = os.path.join(flash_dir,"FlashPlayerTrust","zg.txt")
 setup_util.safe_remove(flash_trust_file)
 #------------ Uninstall sqlcmd utility ------------------
 logging.info("[setup_base.py] uninstall SQL server sqlcmd command line util")
 sqlcmd_setup = setup_util.i4j["sys.installationDir"]+"\\db\\dist\\SqlCmdLnUtils.msi"
 if os.path.exists(sqlcmd_setup):
  setup_opts=' /x {D9F711D3-3C90-4D79-9292-47C90C722E2A}'
  setup_cmd=setup_util._CmdMsiexec+" /qb "
  if "UNATTENDED" in os.environ:
   setup_cmd=setup_util._CmdMsiexec+" /qn "
  setup_util.psysi(setup_cmd+setup_opts)
 #------------ Uninstall SQL server native client ------------------
 sqlncli_setup = setup_util.i4j["sys.installationDir"]+"\\db\\dist\\sqlncli.msi"
 if setup_util.sc_exists("MSSQL$SQLEXPRESS") or setup_util.sc_exists("MSSQLSERVER"):
  logging.info("[setup_base.py] keep SQL server native client for dependent SQL installation")
 elif os.path.exists(sqlncli_setup):
  logging.info("[setup_base.py] uninstall SQL server native client")
  setup_opts=' /x {2180B33F-3225-423E-BBC1-7798CFD3CD1F}'
  setup_cmd=setup_util._CmdMsiexec+" /qb "
  if "UNATTENDED" in os.environ:
   setup_cmd=setup_util._CmdMsiexec+" /qn "
  setup_util.psysi(setup_cmd+setup_opts)
 logging.info("[setup_base.py] done uninstall()")

''' Standard setup script main function
	 * The python installer script must implement the following methods
	 * -i install
	 * -p upgrade based on version spec
	 * -m maintain for upgrade
	 * -x complete uninstall
'''
def main():
 setup_util.init()
 try:
  if sys.argv[1]=="-i":
   install()
  elif sys.argv[1]=="-p":
   migrate_call = getattr(sys.modules[__name__],"migrate_"+setup_util.i4j["tm.migrate.v"],None)
   if not None==migrate_call:
    migrate_call()
  elif sys.argv[1]=="-m":
   maintain()
  elif sys.argv[1]=="-x":
   uninstall()
  setup_util.set_progress(100)  
  return 0
 except Exception, x:
  logging.exception(x)
  setup_util.set_progress(999)  
  return -1 

if __name__=="__main__":
 sys.exit(main())
